Attribute VB_Name = "MODTranslate"
'===============================================================================
'   send comments to
'   fredjust@hotmail.com
'   http://fred.just.free.fr/
'===============================================================================

Option Explicit

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

' Add a "Microsoft scripting runtime" REFERENCE only on VB6
Dim FSO As FileSystemObject
Dim TextStream As TextStream

Dim tempo As String
Dim Obj As Control
Dim phrase
Dim CaptionCollection As Collection
Dim ObjIndex As Long
Public Translation As New Collection

Global gstrFileLNG As String

'==================================================================================
'   Save all caption, tooltiptext, and Sentences of the Translation collection
'==================================================================================
Public Sub SaveAllName(ByVal aForm As Form, ByVal Filename As String)
Dim i As Long

    On Error Resume Next
    
    gstrFileLNG = Filename
    
    Set FSO = New FileSystemObject
    
    ' Create the text file
    Set TextStream = FSO.CreateTextFile(Filename, True)
    
    ' write produc name
    TextStream.WriteLine "[" & App.ProductName & "] don't translate this line and the name before '='"
    ' write the caption of form
    TextStream.WriteLine aForm.Name & ".Caption=" & aForm.Caption

    For Each Obj In aForm

        tempo = ""
        Err.Clear
        ObjIndex = Obj.Index

        
        If Err.Number <> 0 Then ' if the object is not indexed

            tempo = Obj.Caption

            If tempo <> "" Then
                ' write Caption of the object
                TextStream.WriteLine Obj.Name & ".Caption=" & tempo
            End If

            tempo = ""
            tempo = Obj.ToolTipText

            If tempo <> "" Then
                ' write ToolTipText of the object
                TextStream.WriteLine Obj.Name & ".ToolTipText=" & tempo
            End If

        Else        ' if the object is indexed

            tempo = Obj.Caption

            If tempo <> "" Then
                ' write Caption of the object
                TextStream.WriteLine Obj.Name & "(" & Obj.Index & ").Caption=" & tempo
            End If

            tempo = ""
            tempo = Obj.ToolTipText

            If tempo <> "" Then
                ' write ToolTipText of the object
                TextStream.WriteLine Obj.Name & "(" & Obj.Index & ").ToolTipText=" & tempo
            End If

        End If

    Next

    ' End of this section IMPORTANT it's use in the LOAD function
    TextStream.WriteLine "[END CAPTION] - don't translate this line"
    TextStream.WriteLine ""
    TextStream.WriteLine "[MSG]"
    ' write all sentence
    i = 1
    For Each phrase In Translation
        TextStream.WriteLine "msg" & CStr(i) & "=" & phrase
        i = i + 1
    Next

    TextStream.Close
    Set FSO = Nothing
End Sub

'==================================================================================
'   Load and change Caption and toolTipText
'==================================================================================
Public Sub LoadAllName(aForm As Form, ByVal Filename As String)
    Dim BeginName  As Long

    On Error Resume Next
    Set FSO = New FileSystemObject
    
    ' open the text file
    Set TextStream = FSO.OpenTextFile(Filename, ForReading)
    gstrFileLNG = Filename
    'clear the collection
    Set CaptionCollection = New Collection

    tempo = TextStream.ReadLine
    
    ' is the file is for this application ?
    If InStr(1, tempo, App.ProductName) = 0 Then
        MsgBox "The file is invalid !"
        Set CaptionCollection = Nothing
        TextStream.Close
        Exit Sub
    End If

    ' caption form on the 2 line
    tempo = TextStream.ReadLine
    BeginName = InStr(1, tempo, "=")
    aForm.Caption = Mid(tempo, BeginName + 1)

    tempo = TextStream.ReadLine

    ' read all caption and tooltiptext which are in the file
    While InStr(1, tempo, "[END CAPTION]") = 0 And Err.Number = 0
        BeginName = InStr(1, tempo, "=")
        CaptionCollection.Add Mid(tempo, BeginName + 1), Mid(tempo, 1, BeginName - 1)
        tempo = TextStream.ReadLine
    Wend

    ' no error (we found [END CAPTION] in the file)
    If Err.Number = 0 Then
    
        For Each Obj In aForm

            Err.Clear
            ObjIndex = Obj.Index

            'if the objet is indexed
            If Err.Number = 0 Then
                ' change caption of object
                Obj.Caption = CaptionCollection(Obj.Name & "(" & Obj.Index & ").Caption")
                ' change tooltiptext of object
                Obj.ToolTipText = CaptionCollection(Obj.Name & "(" & Obj.Index & ").tooltiptext")
            Else
                ' change caption of object
                Obj.Caption = CaptionCollection(Obj.Name & ".Caption")
                ' change tooltiptext of object
                Obj.ToolTipText = CaptionCollection(Obj.Name & ".tooltiptext")
            End If

        Next
    Else
        MsgBox "The file is invalid !"
    End If

    TextStream.Close
    Set FSO = Nothing
    Set CaptionCollection = Nothing
End Sub

'===============================================================================
'   return the translation of a sentence
'   if it doesn't exist the sentence wasn't translate
'===============================================================================
Public Function Translate(sentence As String) As String
    On Error Resume Next
    'Translate = Translation(sentence)
    'If Err.Number <> 0 Then Translate = sentence
    
   Translate = ReadIniFile(gstrFileLNG, "MSG", sentence, "")
End Function



Private Function ReadIniFile(ByVal FileIni As String, ByVal SectionName As String, ByVal KeyName As String, ByVal DefaultValue As String) As String
    Dim Ret As String, NC As Long
    
    'Create a buffer
    Ret = Space(1024)
    'Retrieve the string
    NC = GetPrivateProfileString(SectionName, KeyName, DefaultValue, Ret, 512, FileIni)
    'NC is the number of characters copied to the buffer
    Ret = Left$(Ret, NC)
    'Show our string
    ReadIniFile = Ret
End Function
